## org.apache.http.nio
Interface NHttpClientEventHandler

All Known Implementing Classes:
  HttpAsyncRequestExecutor

    public interface NHttpClientEventHandler

Abstract client-side HTTP protocol handler.

Since:
  4.2

Method Summary
`void` `closed(NHttpClientConnection conn)` Triggered when the connection is closed.
`void` `connected(NHttpClientConnection conn, Object attachment)` Triggered when a new outgoing connection is created.
`void` `endOfInput(NHttpClientConnection conn)` Triggered when the connection is closed by the opposite end point (half-closed).
`void` `exception(NHttpClientConnection conn, Exception ex)` Triggered if an error occurs during the HTTP exchange.
`void` `inputReady(NHttpClientConnection conn, ContentDecoder decoder)` Triggered when the underlying channel is ready for reading a new portion of the response entity through the corresponding content decoder.
`void` `outputReady(NHttpClientConnection conn, ContentEncoder encoder)` Triggered when the underlying channel is ready for writing a next portion of the request entity through the corresponding content encoder.
`void` `requestReady(NHttpClientConnection conn)` Triggered when the connection is ready to accept a new HTTP request.
`void` `responseReceived(NHttpClientConnection conn)` Triggered when an HTTP response is received.
`void` `timeout(NHttpClientConnection conn)` Triggered when no input is detected on this connection over the maximum period of inactivity.

Method Detail

### connected

    void connected(NHttpClientConnection conn,
                   Object attachment)
                   throws IOException,
                          HttpException

  Triggered when a new outgoing connection is created.

  Parameters:
    `conn` - new outgoing HTTP connection.
    `attachment` - an object that was attached to the session request
  Throws:
    `IOException`
    `HttpException`

### requestReady

    void requestReady(NHttpClientConnection conn)
                      throws IOException,
                             HttpException

  Triggered when the connection is ready to accept a new HTTP request. The protocol handler does not have to submit a request if it is not ready.

  Parameters:
    `conn` - HTTP connection that is ready to accept a new HTTP request.
  Throws:
    `IOException`
    `HttpException`
  See Also:
    `NHttpClientConnection`

### responseReceived

    void responseReceived(NHttpClientConnection conn)
                          throws IOException,
                                 HttpException

  Triggered when an HTTP response is received. The connection passed as a parameter to this method is guaranteed to return a valid HTTP response object.

  If the response received encloses a response entity this method will be followed by a series of `inputReady(NHttpClientConnection, ContentDecoder)` calls to transfer the response content.

  Parameters:
    `conn` - HTTP connection that contains an HTTP response
  Throws:
    `IOException`
    `HttpException`
  See Also:
    `NHttpClientConnection`

### inputReady

    void inputReady(NHttpClientConnection conn,
                    ContentDecoder decoder)
                    throws IOException,
                           HttpException

  Triggered when the underlying channel is ready for reading a new portion of the response entity through the corresponding content decoder.

  If the content consumer is unable to process incoming content, input event notifications can be temporarily suspended using `IOControl` interface (super interface of `NHttpClientConnection`).

  Please note that the `NHttpClientConnection` and `ContentDecoder` objects are not thread-safe and should only be used within the context of this method call. The `IOControl` object can be shared and used on other thread to resume input event notifications when the handler is capable of processing more content.

  Parameters:
    `conn` - HTTP connection that can produce a new portion of the incoming response content.
    `decoder` - The content decoder to use to read content.
  Throws:
    `IOException`
    `HttpException`
  See Also:
    `NHttpClientConnection`, `ContentDecoder`, `IOControl`

### outputReady

    void outputReady(NHttpClientConnection conn,
                     ContentEncoder encoder)
                     throws IOException,
                            HttpException

  Triggered when the underlying channel is ready for writing a next portion of the request entity through the corresponding content encoder.

  If the content producer is unable to generate outgoing content, output event notifications can be temporarily suspended using `IOControl` interface (super interface of `NHttpClientConnection`).

  Please note that the `NHttpClientConnection` and `ContentEncoder` objects are not thread-safe and should only be used within the context of this method call. The `IOControl` object can be shared and used on other thread to resume output event notifications when more content is made available.

  Parameters:
    `conn` - HTTP connection that can accommodate a new portion of the outgoing request content.
    `encoder` - The content encoder to use to write content.
  Throws:
    `IOException`
    `HttpException`
  See Also:
    `NHttpClientConnection`, `ContentEncoder`, `IOControl`

### endOfInput

    void endOfInput(NHttpClientConnection conn)
                    throws IOException

  Triggered when the connection is closed by the opposite end point (half-closed).

  Parameters:
    `conn` - half-closed HTTP connection.
  Throws:
    `IOException`

### timeout

    void timeout(NHttpClientConnection conn)
                 throws IOException,
                        HttpException

  Triggered when no input is detected on this connection over the maximum period of inactivity.

  Parameters:
    `conn` - HTTP connection that caused timeout condition.
  Throws:
    `IOException`
    `HttpException`

### closed

    void closed(NHttpClientConnection conn)

  Triggered when the connection is closed.

  Parameters:
    `conn` - closed HTTP connection.

### exception

    void exception(NHttpClientConnection conn,
                   Exception ex)

  Triggered if an error occurs during the HTTP exchange.

  Parameters:
    `conn` - HTTP connection that caused an I/O error
    `ex` - exception

Copyright © 2005-2013 The Apache Software Foundation. All Rights Reserved.